// ClientList.cpp : implementation file
//

#include "stdafx.h"
#include "TestDb.h"
#include "ClientList.h"
#include "Database.h"
#include "ClientTp.h"
#include "EditClient.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern CTvdbcDatabase theDatabase;
/////////////////////////////////////////////////////////////////////////////
// CClientList

IMPLEMENT_DYNCREATE(CClientList, CFormView)

CClientList::CClientList()
	: CFormView(CClientList::IDD)
{
	//{{AFX_DATA_INIT(CClientList)
	//}}AFX_DATA_INIT
}

CClientList::~CClientList()
{
}

void CClientList::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CClientList)
	DDX_Control(pDX, IDC_BUTTON_EDIT, m_BtEdit);
	DDX_Control(pDX, IDC_BUTTON_DELETE, m_BtDelete);
	DDX_Control(pDX, IDC_LIST_CLIENTS, m_ListClients);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CClientList, CFormView)
	//{{AFX_MSG_MAP(CClientList)
	ON_BN_CLICKED(IDC_RADIO_CITY, OnRadioCity)
	ON_BN_CLICKED(IDC_RADIO_COMP, OnRadioComp)
	ON_BN_CLICKED(IDC_RADIO_ID, OnRadioId)
	ON_BN_CLICKED(IDC_RADIO_NAME, OnRadioName)
	ON_BN_CLICKED(IDC_BUTTON_ADD, OnButtonAdd)
	ON_BN_CLICKED(IDC_BUTTON_DELETE, OnButtonDelete)
	ON_BN_CLICKED(IDC_BUTTON_EDIT, OnButtonEdit)
	ON_BN_CLICKED(IDC_BUTTON_CLOSE, OnButtonClose)
	ON_NOTIFY(LVN_GETDISPINFO, IDC_LIST_CLIENTS, OnGetdispinfoListClients)
	ON_NOTIFY(LVN_ITEMCHANGING, IDC_LIST_CLIENTS, OnItemchangingListClients)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CClientList diagnostics

#ifdef _DEBUG
void CClientList::AssertValid() const
{
	CFormView::AssertValid();
}

void CClientList::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CClientList message handlers

BOOL CClientList::Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext) 
{
	RECT Rect;
	CDialog TempDialog;

	TempDialog.Create(IDD);
	
	TempDialog.GetClientRect(&Rect);
	Rect.right -= Rect.left;
	Rect.left = 0;
	Rect.bottom -= Rect.top;
	Rect.top = 0;

	TempDialog.ClientToScreen(&Rect);
	Rect.right -= Rect.left;
	Rect.left = 0;
	Rect.bottom -= Rect.top;
	Rect.top = 0;
	
	AdjustWindowRectEx(&Rect, pParentWnd->GetStyle(), FALSE, pParentWnd->GetExStyle());
	Rect.right -= Rect.left;
	Rect.left = 0;
	Rect.bottom -= Rect.top;
	Rect.top = 0;

	pParentWnd->ScreenToClient(&Rect);
	Rect.right -= Rect.left;
	Rect.left = 0;
	Rect.bottom -= Rect.top;
	Rect.top = 0;
	TempDialog.DestroyWindow();

	pParentWnd->SetWindowPos(NULL, 0, 0, Rect.right, Rect.bottom, SWP_NOMOVE);
	
	return CFormView::Create(lpszClassName, lpszWindowName, dwStyle, rect, pParentWnd, nID, pContext);
}

void CClientList::OnInitialUpdate() 
{
	RECT Rect;
		
	CFormView::OnInitialUpdate();
	m_ListClients.GetClientRect(&Rect);
	
	Rect.right /= 22;
	Rect.right *= 3;
	m_ListClients.InsertColumn(0, "ID", LVCFMT_RIGHT, Rect.right);
	Rect.right *= 2;
	m_ListClients.InsertColumn(1, "Company", LVCFMT_LEFT, Rect.right);
	m_ListClients.InsertColumn(2, "Name", LVCFMT_LEFT, Rect.right);
	m_ListClients.InsertColumn(3, "City", LVCFMT_LEFT, Rect.right);
	QueryId = 0;
	SeekQuery = FALSE;
	JumpCurrentRecordId = 0;
	
	OnRadioId();
	SetTimer(1, 1000, NULL);
}

void CClientList::OnRadioCity() 
{
	LV_ITEM Item;
	DWORD i, QueryCount;
	
	UpdateCount = theDatabase.GetUpdateCount(CLIENT_DBID);

	if(QueryId)
		theDatabase.CloseQuery(QueryId);

	QueryId = theDatabase.CreateQuery(0, CLIENT_DBID, CLIENT_CITYKEY);
	if(QueryId < 0)
		theDatabase.AbortFatal(QueryId);
	QueryCount = theDatabase.GetMaxQueryRecord(QueryId);
	if((QueryCount / 2) <= (DWORD)m_ListClients.GetCountPerPage())
		QueryCount /= 2;
	m_ListClients.DeleteAllItems();
	for(i = 0; i < QueryCount; i++)
		m_ListClients.InsertItem(i, LPSTR_TEXTCALLBACK);
	CurrentItem = -1;
	m_BtDelete.EnableWindow(FALSE);
	m_BtEdit.EnableWindow(FALSE);
	m_ListClients.SetFocus();
	Item.mask = LVIF_STATE;
	Item.iItem = CurrentItem;
	Item.iSubItem = 0;
	Item.state = LVIS_SELECTED | LVIS_FOCUSED;
	Item.stateMask = LVIS_SELECTED | LVIS_FOCUSED;
	m_ListClients.SetItemState(0, &Item);
}

void CClientList::OnRadioComp() 
{
	LV_ITEM Item;
	DWORD i, QueryCount;
	
	UpdateCount = theDatabase.GetUpdateCount(CLIENT_DBID);

	if(QueryId)
		theDatabase.CloseQuery(QueryId);

	QueryId = theDatabase.CreateQuery(0, CLIENT_DBID, CLIENT_COMPKEY);
	if(QueryId < 0)
		theDatabase.AbortFatal(QueryId);
	QueryCount = theDatabase.GetMaxQueryRecord(QueryId);
	if((QueryCount / 2) <= (DWORD)m_ListClients.GetCountPerPage())
		QueryCount /= 2;
	m_ListClients.DeleteAllItems();
	for(i = 0; i < QueryCount; i++)
		m_ListClients.InsertItem(i, LPSTR_TEXTCALLBACK);
	CurrentItem = -1;
	m_BtDelete.EnableWindow(FALSE);
	m_BtEdit.EnableWindow(FALSE);

	m_ListClients.SetFocus();	
	Item.mask = LVIF_STATE;
	Item.iItem = CurrentItem;
	Item.iSubItem = 0;
	Item.state = LVIS_SELECTED | LVIS_FOCUSED;
	Item.stateMask = LVIS_SELECTED | LVIS_FOCUSED;
	m_ListClients.SetItemState(0, &Item);
}

void CClientList::OnRadioId()
{
	LV_ITEM Item;
	DWORD i, QueryCount;
	DWORD CurrentRecordId = 0;
	
	UpdateCount = theDatabase.GetUpdateCount(CLIENT_DBID);

	CheckDlgButton(IDC_RADIO_ID, 2);
	CheckDlgButton(IDC_RADIO_COMP, 0);
	CheckDlgButton(IDC_RADIO_NAME, 0);
	CheckDlgButton(IDC_RADIO_CITY, 0);
	
	if(JumpCurrentRecordId)
	{
		CurrentRecordId = JumpCurrentRecordId;
		JumpCurrentRecordId = 0;
	}
	else
	if(QueryId)
	{
		if(theDatabase.QueryGotoRecord(QueryId, CurrentItem))
		{
			CLIENT theClient;
			theDatabase.ReadTableRecord(CLIENT_DBID, &theClient);
			CurrentRecordId = theClient.RecordId;
		}
		theDatabase.CloseQuery(QueryId);
	}
	
	SeekQuery = TRUE;
	QueryId = theDatabase.CreateQuery(0, CLIENT_DBID, CLIENT_IDKEY);
	if(QueryId < 0)
		theDatabase.AbortFatal(QueryId);
	QueryCount = theDatabase.GetMaxQueryRecord(QueryId);
	if((QueryCount / 2) <= (DWORD)m_ListClients.GetCountPerPage())
		QueryCount /= 2;
	m_ListClients.DeleteAllItems();
	for(i = 0; i < QueryCount; i++)
		m_ListClients.InsertItem(i, LPSTR_TEXTCALLBACK);
	CurrentItem = -1;
	m_BtDelete.EnableWindow(FALSE);
	m_BtEdit.EnableWindow(FALSE);
	
	if(CurrentRecordId)
	{
		DWORD ItemNo = 0;
		if(QueryCount <= (DWORD)m_ListClients.GetCountPerPage())
		{
			ItemNo = QueryCount - 1;
			for(i = 0; i < QueryCount; i++)
				if(theDatabase.QueryGotoRecord(QueryId, i))
				{
					CLIENT theClient;
					theDatabase.ReadTableRecord(CLIENT_DBID, &theClient);
					if(theClient.RecordId > CurrentRecordId)
					{
						ItemNo = i;
						break;
					}
				}
		}
		else
		{
			theDatabase.QuerySetSeekKey(QueryId, 0, &CurrentRecordId);
			if(!theDatabase.QueryFindRecord(QueryId, FIND_GREQ))
				ItemNo = theDatabase.GetCurrentQueryRecord(QueryId);
			else
			{
			theDatabase.QuerySetSeekKey(QueryId, 0, &CurrentRecordId);
			if(!theDatabase.QueryFindRecord(QueryId, FIND_LSEQ))
				ItemNo = theDatabase.GetCurrentQueryRecord(QueryId);
			}
		}
		if(ItemNo > 0)
		{
			SeekQuery = TRUE;
			CurrentItem = ItemNo;
			m_ListClients.EnsureVisible(CurrentItem, FALSE);
			SeekQuery = FALSE;
			m_ListClients.SetFocus();
			Item.mask = LVIF_STATE;
			Item.iItem = CurrentItem;
			Item.iSubItem = 0;
			Item.state = LVIS_SELECTED | LVIS_FOCUSED;
			Item.stateMask = LVIS_SELECTED | LVIS_FOCUSED;
			m_ListClients.SetItemState(CurrentItem, &Item);
		}
		else
		{
			SeekQuery = FALSE;
			m_ListClients.SetFocus();
			Item.mask = LVIF_STATE;
			Item.iItem = CurrentItem;
			Item.iSubItem = 0;
			Item.state = LVIS_SELECTED | LVIS_FOCUSED;
			Item.stateMask = LVIS_SELECTED | LVIS_FOCUSED;
			m_ListClients.SetItemState(0, &Item);
		}
	}
	else
	{
		SeekQuery = FALSE;
		m_ListClients.SetFocus();
		Item.mask = LVIF_STATE;
		Item.iItem = CurrentItem;
		Item.iSubItem = 0;
		Item.state = LVIS_SELECTED | LVIS_FOCUSED;
		Item.stateMask = LVIS_SELECTED | LVIS_FOCUSED;
		m_ListClients.SetItemState(0, &Item);
	}
}

void CClientList::OnRadioName() 
{
	LV_ITEM Item;
	DWORD i, QueryCount;
	
	UpdateCount = theDatabase.GetUpdateCount(CLIENT_DBID);

	if(QueryId)
		theDatabase.CloseQuery(QueryId);

	QueryId = theDatabase.CreateQuery(0, CLIENT_DBID, CLIENT_NAMEKEY);
	if(QueryId < 0)
		theDatabase.AbortFatal(QueryId);
	QueryCount = theDatabase.GetMaxQueryRecord(QueryId);
	if((QueryCount / 2) <= (DWORD)m_ListClients.GetCountPerPage())
		QueryCount /= 2;
	m_ListClients.DeleteAllItems();
	for(i = 0; i < QueryCount; i++)
		m_ListClients.InsertItem(i, LPSTR_TEXTCALLBACK);
	CurrentItem = -1;
	m_BtDelete.EnableWindow(FALSE);
	m_BtEdit.EnableWindow(FALSE);
	
	m_ListClients.SetFocus();
	Item.mask = LVIF_STATE;
	Item.iItem = CurrentItem;
	Item.iSubItem = 0;
	Item.state = LVIS_SELECTED | LVIS_FOCUSED;
	Item.stateMask = LVIS_SELECTED | LVIS_FOCUSED;
	m_ListClients.SetItemState(0, &Item);
}

void CClientList::OnButtonAdd() 
{
	CEditClient AddClient(0, this);
	if(AddClient.DoModal())
	{
		CLIENT theClient;
		theDatabase.ReadTableRecord(CLIENT_DBID, &theClient);
		JumpCurrentRecordId = theClient.RecordId;
		OnRadioId();
	}
}

void CClientList::OnButtonDelete() 
{
	if(theDatabase.QueryGotoRecord(QueryId, CurrentItem))
	{
		char temp[256];
		CLIENT theClient;
		theDatabase.ReadTableRecord(CLIENT_DBID, &theClient);
		wsprintf(temp, "Delete %ld, %s, %s?", theClient.RecordId, theClient.CompanyName, theClient.Name);
		if(MessageBox(temp, "Delete", MB_YESNO | MB_DEFBUTTON2) == IDYES)
		{
			if(theDatabase.DeleteRecord(CLIENT_DBID, FALSE))
				MessageBox("Error deleting record!");
			else
				OnRadioId();
		}
	}
}

void CClientList::OnButtonEdit() 
{
	if(theDatabase.QueryGotoRecord(QueryId, CurrentItem))
	{
		CLIENT theClient;
		theDatabase.ReadTableRecord(CLIENT_DBID, &theClient);
		CEditClient AddClient(theClient.RecordId, this);
		if(AddClient.DoModal())
			OnRadioId();
	}
}


void CClientList::OnButtonClose() 
{
	GetParent()->DestroyWindow();
}

void CClientList::OnGetdispinfoListClients(NMHDR* pNMHDR, LRESULT* pResult) 
{
	LV_DISPINFO* pDispInfo = (LV_DISPINFO*)pNMHDR;
	if(SeekQuery)
		return;
	if(pDispInfo->hdr.code ==	LVN_GETDISPINFO)
		if(pDispInfo->item.mask == LVIF_TEXT)
		{
			if(theDatabase.QueryGotoRecord(QueryId, pDispInfo->item.iItem))
			{
				CLIENT theClient;
				theDatabase.ReadTableRecord(CLIENT_DBID, &theClient);
				switch(pDispInfo->item.iSubItem)
				{
					case 0:
						wsprintf(pDispInfo->item.pszText, "%ld", theClient.RecordId);
						break;
					case 1:
						strcpy(pDispInfo->item.pszText, theClient.CompanyName);
						break;
					case 2:
						strcpy(pDispInfo->item.pszText, theClient.Name);
						break;
					case 3:
						strcpy(pDispInfo->item.pszText, theClient.City);
						break;
				}
			}
			else
			{
				strcpy(pDispInfo->item.pszText, "");
				switch(theDatabase.QueryGetSearchMode(QueryId))
				{
					case SORT_ASC:
						if((m_ListClients.GetTopIndex() + m_ListClients.GetCountPerPage()) == pDispInfo->item.iItem)
							break;
						if(!m_ListClients.GetTopIndex())
							break;
						m_ListClients.EnsureVisible(m_ListClients.GetTopIndex() - 1, FALSE);
						break;
					case SORT_DESC:
						m_ListClients.EnsureVisible(m_ListClients.GetTopIndex() + m_ListClients.GetCountPerPage(), FALSE);
						break;
					case SORT_FIND:
						if(pDispInfo->item.iItem == m_ListClients.GetTopIndex())
							m_ListClients.EnsureVisible(m_ListClients.GetTopIndex() + m_ListClients.GetCountPerPage(), FALSE);
						break;
				}
			}
		}
	
	*pResult = 0;
}


void CClientList::OnItemchangingListClients(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_LISTVIEW* pNMListView = (NM_LISTVIEW*)pNMHDR;
	// TODO: Add your control notification handler code here
	if(SeekQuery)
		return;
	if(!theDatabase.QueryGotoRecord(QueryId, pNMListView->iItem))
	{
		if(CurrentItem >= 0)
		{
			LV_ITEM Item;
			Item.mask = LVIF_STATE;
			Item.iItem = CurrentItem;
			Item.iSubItem = 0;
			Item.state = LVIS_SELECTED | LVIS_FOCUSED;
			Item.stateMask = LVIS_SELECTED | LVIS_FOCUSED;
			m_ListClients.SetItemState(CurrentItem, &Item);
		}
		else
		{
			m_BtDelete.EnableWindow(FALSE);
			m_BtEdit.EnableWindow(FALSE);
		}
		*pResult = TRUE;
	}
	else
	{
		*pResult = FALSE;
		CurrentItem = pNMListView->iItem;
		m_BtDelete.EnableWindow(TRUE);
		m_BtEdit.EnableWindow(TRUE);
	}
}

void CClientList::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	
	CFormView::OnTimer(nIDEvent);
	if(UpdateCount != theDatabase.GetUpdateCount(CLIENT_DBID))
		OnRadioId();
}
