// EditClient.cpp : implementation file
//

#include "stdafx.h"
#include "TestDb.h"
#include "EditClient.h"
#include "Database.h"
#include "ClientTp.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CEditClient dialog
extern CTvdbcDatabase theDatabase;

CEditClient::CEditClient(DWORD RecordId, CWnd* pParent /*=NULL*/)
	: CDialog(CEditClient::IDD, pParent)
{
	//{{AFX_DATA_INIT(CEditClient)
	//}}AFX_DATA_INIT
	CurrentRecordId = RecordId;
}


void CEditClient::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CEditClient)
	DDX_Control(pDX, IDC_EDIT_STREET, m_EdtStreet);
	DDX_Control(pDX, IDC_EDIT_NAME, m_EdtName);
	DDX_Control(pDX, IDC_EDIT_INFO, m_EdtInfo);
	DDX_Control(pDX, IDC_EDIT_COMPANY, m_EdtCompany);
	DDX_Control(pDX, IDC_EDIT_CITY, m_EdtCity);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CEditClient, CDialog)
	//{{AFX_MSG_MAP(CEditClient)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEditClient message handlers

void CEditClient::OnOK() 
{
	CLIENT theClient;
	short err;

	if(CurrentRecordId)
	{
		theDatabase.GotoRecord(CLIENT_DBID, CurrentRecordId);
		theDatabase.ReadTableRecord(CLIENT_DBID, &theClient);
	}

	m_EdtCompany.GetWindowText(theClient.CompanyName, 61);
	m_EdtName.GetWindowText(theClient.Name, 61);
	m_EdtStreet.GetWindowText(theClient.Street, 61);
	m_EdtCity.GetWindowText(theClient.City, 61);
	theDatabase.WriteTableRecord(CLIENT_DBID, &theClient);
	if(CurrentRecordId)
		err = theDatabase.UpdateRecord(CLIENT_DBID);
	else
		err = theDatabase.AddRecord(CLIENT_DBID);
	if(err < 0)
	{
		char ErrorText[256];
		theDatabase.GetErrorText(err, ErrorText);
		MessageBox(ErrorText);
		return;
	}

	if(m_EdtInfo.GetWindowTextLength())
	{
		int Size = m_EdtInfo.GetWindowTextLength() + 1;
		LPSTR MemoField = new char[Size];
		if(MemoField)
		{
			m_EdtInfo.GetWindowText(MemoField, Size);
			theDatabase.WriteTableMemoField(CLIENT_DBID, CLIENT_MEMOID, MemoField, Size);
			delete MemoField;
		}
		else
			theDatabase.WriteTableMemoField(CLIENT_DBID, CLIENT_MEMOID, NULL, 0);
	}
	else
		theDatabase.WriteTableMemoField(CLIENT_DBID, CLIENT_MEMOID, NULL, 0);
	
	CDialog::OnOK();
}

BOOL CEditClient::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	if(CurrentRecordId)
	{
		CLIENT theClient;
		DWORD Size = theDatabase.ReadTableMemoFieldSize(CLIENT_DBID, CLIENT_MEMOID);
		
		SetWindowText("Edit Client");
		theDatabase.ReadTableRecord(CLIENT_DBID, &theClient);
		m_EdtCompany.SetWindowText(theClient.CompanyName);
		m_EdtName.SetWindowText(theClient.Name);
		m_EdtStreet.SetWindowText(theClient.Street);
		m_EdtCity.SetWindowText(theClient.City);
		if(Size)
		{
			LPSTR MemoField = new char[Size];
			if(MemoField)
			{
				theDatabase.ReadTableMemoField(CLIENT_DBID, CLIENT_MEMOID, MemoField);
				m_EdtInfo.SetWindowText(MemoField);
				delete MemoField;
			}
		}
	}
	
	return TRUE; 
}
