// TestDb.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "TestDb.h"

#include "MainFrm.h"
#include "ChildFrm.h"
#include "TestDbDoc.h"
#include "ClientList.h"
#include "Database.h"
#include "ClientTp.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTestDbApp

BEGIN_MESSAGE_MAP(CTestDbApp, CWinApp)
	//{{AFX_MSG_MAP(CTestDbApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
	// Standard file based document commands
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
	// Standard print setup command
	ON_COMMAND(ID_FILE_PRINT_SETUP, CWinApp::OnFilePrintSetup)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTestDbApp construction

CTestDbApp::CTestDbApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CTestDbApp object

CTestDbApp theApp;
CTvdbcDatabase theDatabase;

/////////////////////////////////////////////////////////////////////////////
// CTestDbApp initialization

BOOL CTestDbApp::InitInstance()
{
	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif

	LoadStdProfileSettings(0);  // Load standard INI file options (including MRU)

	// Register the application's document templates.  Document templates
	//  serve as the connection between documents, frame windows and views.

	CMultiDocTemplate* pDocTemplate;
	pDocTemplate = new CMultiDocTemplate(
		IDR_TESTDBTYPE,
		RUNTIME_CLASS(CTestDbDoc),
		RUNTIME_CLASS(CChildFrame), // custom MDI child frame
		RUNTIME_CLASS(CClientList));
	AddDocTemplate(pDocTemplate);

	// create main MDI Frame window
	CMainFrame* pMainFrame = new CMainFrame;
	if (!pMainFrame->LoadFrame(IDR_MAINFRAME))
		return FALSE;
	m_pMainWnd = pMainFrame;

	// Parse command line for standard shell commands, DDE, file open
	CCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);
	
	OpenDatabase();

	// Dispatch commands specified on the command line
	if (!ProcessShellCommand(cmdInfo))
		return FALSE;
	

	// The main window has been initialized, so show and update it.
	pMainFrame->ShowWindow(m_nCmdShow);
	pMainFrame->UpdateWindow();
	
	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
		// No message handlers
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// App command to run the dialog
void CTestDbApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}

/////////////////////////////////////////////////////////////////////////////
// CTestDbApp commands

void CTestDbApp::OpenDatabase()
{
	short err = theDatabase.OpenDatabase("Clients.Dbx", OPEN_NORMAL);
	switch(err)
	{
		case ERR_FILE_NOTFOUND:
			CreateDatabase();
			err = theDatabase.OpenDatabase("Clients.Dbx", OPEN_NORMAL);
		default:
			if(err < 0)
				theDatabase.AbortFatal(err);
			break;
	}
}

void CTestDbApp::CreateDatabase()
{
	short err = theDatabase.CreateDatabase("Clients.Dbx");
	if(err < 0)
		theDatabase.AbortFatal(err);
	
	err = theDatabase.CreateTable("Clients");
	if(err < 0)
		theDatabase.AbortFatal(err);
	err = theDatabase.CreateTableField(CLIENT_DBID, "CompanyName", FIELD_CHAR, 61);
	if(err < 0)
		theDatabase.AbortFatal(err);
	err = theDatabase.CreateTableField(CLIENT_DBID, "Name", FIELD_CHAR, 61);
	if(err < 0)
		theDatabase.AbortFatal(err);
	err = theDatabase.CreateTableField(CLIENT_DBID, "Street", FIELD_CHAR, 61);
	if(err < 0)
		theDatabase.AbortFatal(err);
	err = theDatabase.CreateTableField(CLIENT_DBID, "City", FIELD_CHAR, 61);
	if(err < 0)
		theDatabase.AbortFatal(err);
	err = theDatabase.CreateTableField(CLIENT_DBID, "ClientInfo", FIELD_MEMO);
	if(err < 0)
		theDatabase.AbortFatal(err);
	
	err = theDatabase.CreateTableKey(CLIENT_DBID, "CompanyName", FALSE, TRUE);
	if(err < 0)
		theDatabase.AbortFatal(err);
	err = theDatabase.CreateTableKeyField(CLIENT_DBID, CLIENT_COMPKEY, 3);
	if(err < 0)
		theDatabase.AbortFatal(err);
	err = theDatabase.CreateTableKey(CLIENT_DBID, "Name", FALSE, TRUE);
	if(err < 0)
		theDatabase.AbortFatal(err);
	err = theDatabase.CreateTableKeyField(CLIENT_DBID, CLIENT_NAMEKEY, 4);
	if(err < 0)
		theDatabase.AbortFatal(err);
	err = theDatabase.CreateTableKey(CLIENT_DBID, "City", FALSE, TRUE);
	if(err < 0)
		theDatabase.AbortFatal(err);
	err = theDatabase.CreateTableKeyField(CLIENT_DBID, CLIENT_CITYKEY, 6);
	if(err < 0)
		theDatabase.AbortFatal(err);

	theDatabase.EndCreateDatabase();
	if(err < 0)
		theDatabase.AbortFatal(err);
}
